rm(list=ls())
library(rjags)
setwd("J:/jesarey_documents/Comp-Bayes Course/Lecture 6 - Bayesian V")
set.seed(39812)

ideal.points<-rnorm(20, mean=0, sd=1)
vote.midpoints<-runif(100, min=-2, max=2)

vote<-matrix(data=NA, nrow=20, ncol=100)
pr<-matrix(data=NA, nrow=20, ncol=100)
for(i in 1:20){
  
  for(j in 1:100){

    index<-ideal.points[i]-vote.midpoints[j]
    pr[i,j]<-pnorm(index)
    vote[i,j]<-ifelse(runif(1)<pr[i,j],1,0)
        
  }
  
}

data<- list("N" = 20, "M"=100, "Y"=vote)
inits <- function() {list (mu.delta=0, tau.delta=1)}
parameters<- c("delta", "theta")

irt.model<-jags.model(file="irt.bug", data, inits, n.chains=1, n.adapt=500)
update(irt.model, n.iter=1000) # burn in
irt.samples<-coda.samples(irt.model, variable.names=parameters, n.iter=2000)

theta.est<-colMeans(irt.samples[[1]][,101:120])
plot(theta.est~ideal.points)
abline(0,1, lty=2)
slope<-lm(theta.est~ideal.points)$coefficients
abline(slope[1],slope[2], lty=1)


delta.est<-colMeans(irt.samples[[1]][,1:100])
plot(delta.est~vote.midpoints)
abline(0,1, lty=2)
slope<-lm(delta.est~vote.midpoints)$coefficients
abline(slope[1],slope[2], lty=1)

pr.est<-matrix(data=NA, nrow=20, ncol=100)
for(i in 1:20){
  
  for(j in 1:100){
    
    index<-theta.est[i]-delta.est[j]
    pr.est[i,j]<-pnorm(index)
    
  }
  
}

plot(pr~pr.est)
abline(0,1)
















rm(list=ls())
library(rjags)
setwd("J:/jesarey_documents/Comp-Bayes Course/Lecture 6 - Bayesian V")
set.seed(39812)

ideal.points<-rnorm(20, mean=0, sd=1)
o<-order(ideal.points)
ideal.points<-ideal.points[o]
vote.midpoints<-runif(100, min=-2, max=2)

vote<-matrix(data=NA, nrow=20, ncol=100)
for(i in 1:20){
  
  for(j in 1:100){
    
    index<-ideal.points[i]-vote.midpoints[j]
    pr<-pnorm(index)
    vote[i,j]<-ifelse(runif(1)<pr,1,0)
    
  }
  
}

data<- list("N" = 20, "M"=100, "Y"=vote, "theta.init"=ideal.points[c(1,20)])
inits <- function() {list (mu.delta=0, tau.delta=1)}
parameters<- c("delta", "theta")

irt.model<-jags.model(file="irt_a.bug", data, inits, n.chains=1, n.adapt=500)
update(irt.model, n.iter=1000) # burn in
irt.samples<-coda.samples(irt.model, variable.names=parameters, n.iter=2000)

theta.est<-colMeans(irt.samples[[1]][,101:120])
plot(theta.est~ideal.points)
abline(0,1, lty=2)
slope<-lm(theta.est~ideal.points)$coefficients
abline(slope[1],slope[2], lty=1)


delta.est<-colMeans(irt.samples[[1]][,1:100])
plot(delta.est~vote.midpoints)
abline(0,1, lty=2)
slope<-lm(delta.est~vote.midpoints)$coefficients
abline(slope[1],slope[2], lty=1)

















rm(list=ls())
library(rjags)
setwd("J:/jesarey_documents/Comp-Bayes Course/Lecture 6 - Bayesian V")
set.seed(39812)

ideal.points<-rnorm(20, mean=0, sd=1)
vote.midpoints<-runif(100, min=-2, max=2)
alpha<-rnorm(100, mean=0.5, sd=0.25)
alpha<-pmax(alpha, 0)

vote<-matrix(data=NA, nrow=20, ncol=100)
for(i in 1:20){
  
  for(j in 1:100){
    
    index<-alpha[j]*(ideal.points[i]-vote.midpoints[j])
    pr<-pnorm(index)
    vote[i,j]<-ifelse(runif(1)<pr,1,0)
    
  }
  
}



data<- list("N" = 20, "M"=100, "Y"=vote)
inits <- function() {list (mu.delta=0, tau.delta=1, mu.alpha=1, tau.alpha=1)}
parameters<- c("alpha", "delta", "theta")

irt2.model<-jags.model(file="irt2.bug", data, inits, n.chains=1, n.adapt=500)
update(irt2.model, n.iter=1000) # burn in
irt2.samples<-coda.samples(irt2.model, variable.names=parameters, n.iter=2000)

delta.est<-colMeans(irt2.samples[[1]][,101:200])
plot(delta.est~vote.midpoints)
abline(0,1, lty=2)
slope2<-lm(delta.est~vote.midpoints)$coefficients
abline(slope2[1],slope2[2], lty=1)
cor(delta.est,vote.midpoints)


alpha.est<-colMeans(irt2.samples[[1]][,1:100])
plot(alpha.est~alpha)
abline(0,1, lty=2)
slope2<-lm(alpha.est~alpha)$coefficients
abline(slope2[1],slope2[2], lty=1)
cor(alpha.est,alpha)














rm(list=ls())
library(rjags)
library(pscl)
setwd("J:/jesarey_documents/Comp-Bayes Course/Lecture 6 - Bayesian V")
set.seed(98098)

ideal.points.1<-c(-1,0,1,rnorm(17, mean=0, sd=1))
vote.midpoints.1<-runif(100, min=-1, max=1)
ideal.points.2<-c(0,1,0, rnorm(17, mean=0, sd=1))
vote.midpoints.2<-runif(100, min=-1, max=1)
b1<-runif(100, min=-1, max=1)
b2<-runif(100, min=-1, max=1)


vote<-matrix(data=NA, nrow=20, ncol=100)


for(i in 1:20){
  
  for(j in 1:100){
    
    index<-(b1[j]*ideal.points.1[i]-vote.midpoints.1[j])+(b2[j]*ideal.points.2[i]-vote.midpoints.2[j])
    pr<-pnorm(index)
    vote[i,j]<-ifelse(runif(1)<pr,1,0)
    
  }
  
}



data<- list("N" = 20, "M"=100, "Y"=vote, "theta.init.1" = c(-1, 0), "theta.init.2" = c(0, 1), "theta.init.3" = c(1,0))
inits <- function() {list (mu.delta.1=0, tau.delta.1=1, mu.delta.2=0, tau.delta.2=1, mu.beta.1=1, tau.beta.1=1, mu.beta.2=1, tau.beta.2=1)}
parameters<- c("delta", "theta", "beta")

irt2.model<-jags.model(file="irt_2d.bug", data, inits, n.chains=1, n.adapt=500)
update(irt2.model, n.iter=1000) # burn in
irt2.samples<-coda.samples(irt2.model, variable.names=parameters, n.iter=2000)

theta.est<-colMeans(irt2.samples[[1]][,401:440])
theta.est.mat<-matrix(data=theta.est, ncol=2, byrow=F)

plot(theta.est.mat[,2]~theta.est.mat[,1], xlim=c(-2, 2), ylim=c(-2, 2))
points(ideal.points.2~ideal.points.1, pch=2)
cor(ideal.points.2, theta.est.mat[,2])
cor(ideal.points.1, theta.est.mat[,1])












require(pscl)
data(s109)
is(s109,"rollcall") ## TRUE
s109 ## print method for class rollcall
summary(s109) ## summary method
summary(s109,verbose=TRUE)

cl2 <- constrain.legis(s109,
                       x=list("KENNEDY"=c(-1,0),
                              "ENZI"=c(1,0),
                              "CHAFEE"=c(0,-.5)),
                       d=2)



id2Constrained <- ideal(s109,
                        d=2,
                        priors=cl2, ## priors (w constraints)
                        startvals=cl2, ## start value (w constraints)
                        store.item=TRUE,
                        maxiter=5000,
                        burnin=500,
                        thin=25)

summary(id2Constrained)
plot(id2Constrained, conf.int=0.95, burnin=NULL, overlayCuttingPlanes=F)






